import java.io.*;

//
// wrapper class for DVM C library
//
public abstract class JavaDVM
{
  //
  // define the constants used by DVM
  //

  public static PrintStream ff2 = null;
 
  public final static int INPUT=1;
  public final static int OUTPUT=2;

  public final static int VDCEERECV=0;
  public final static int VDCESEND=1;

  public final static int File=0;
  public final static int Interger=1;
  public final static int Char=2;
  public final static int Float=3;
  public final static int Structure=4;

  // define the constants for messages between L-CVM and DVM

  // communication type
  public final static int SOCKET=0;
  public final static int MPI   =1;
  public final static int P4    =2;
  public final static int DSM   =3;
  public final static int NCS   =4;
  public final static int PVM   =5;

  // communication protocol
  public final static int TCP   =0;
  public final static int ATM   =1;


  // vdce_main
  public static native int vdcemain(String argv[], String targv[]);

  // vdce_init
  // public static native int vdceinit
  //              (int cvmargc, String cvmargv[], int argc[], String argv[]);
 
  // public static native int vdcerun(int argc, String argv[]);

  // vdce_end
  public static native int vdceend(int flag);

  // vdce_stop
  public static native int vdcestop(int flag);

  // vdce_error
  public static native int vdceerror(int flag);

  // vdce_recv
  public static native String vdcerecv(int port);

  // vdce_send
  public static native int vdcesend(int port, char buf[],int nsize);

  // vdce_get_port
  public static native int vdcegetport(int port, int flag);

  // vdce_data_represent
  public static native int vdcedatarepresent(int port, int flag);

  // vdce_input_name
  public static native String vdceinputname(int taskid, int port);

  // vdce_output_name
  public static native String vdceoutputname(int taskid, int port);

  // vdce_get_taskinfo
  public static native int vdcegettaskinfo();

  // vdce_set_taskname
  public static native int vdcesettaskname(String mytask[], String taskname[]);

  // vdce_set_inputs
  public static native int vdcesetinputs(String mytask[], String names[]);

  // vdce_set_outputs
  public static native int vdcesettaskoutputs(String mytask[], String names[]);

  // vdce_get_my_id
  public static native int vdcegetmyid();

  // vdce_get_my_name
  public static native String vdcegetmyname();

  // vdce_report_execution time
  public static native int 
         vdcereportexecutiontime(int time_type, long total_time);

  static {

      String out_file;
     out_file = "/tmp/JavaDVM_load";
try {
        FileOutputStream f_out = new FileOutputStream(out_file);
        ff2 = new PrintStream(f_out);
        ff2.println("Threat start!");
   }
   catch(IOException e) {
        System.exit(1);
   }

     ff2.println("Loading JavaDVM shared library...");
     ff2.println("Loading JavaDVM shared library...");
     ff2.println("Loading JavaDVM shared library...");
     ff2.println("Loading JavaDVM shared library...");
     System.loadLibrary("JavaDVM");
     ff2.println("done.");
     ff2.println("done.");
     ff2.println("done.");
     ff2.println("done.");
     ff2.close();
  }
} // end of class JavaDVM
